      Subroutine Cmmttr(jj,kk,ExpR)

C     On input we have a term ExpR 
C     we want to commute terms in positions jj and kk (jj<kk)
C     substitute this pair of operators by delta function times 
C     UVE expressions,
C     perform integration of delta function, i.e., cancel one 
C     of integration momenta

      Use ModXpr
      Use ModDNT
      Use ModMom
      Implicit None
      Type(Expression)                    :: ExpR
      Type(MomExp)                      :: Momen1,Momen2,Argum
      Type(Operator)                     :: A
      Type(Energy)                       :: EnExp
      Integer IPrint,jj,kk,i,ii,j
      Logical Big_Operator, Small_Operator
      COMMON /Print/ IPrint

      Character Lett,Labljj,Lablkk
      
C    Copy momentum expressions from operators in positions kk and jj
      Momen1=ExpR%Oper%OperG(jj)%Argument
      Momen2=ExpR%Oper%OperG(kk)%Argument

C     Momen1 is momexp which will be kept
C     Momen2 is momexp which will be substituted
C     Always keep momexp associated with initial state operators
C     What if both kk and jj are 'a' or 'b' or 'c'??
      If(  Small_Operator(ExpR%Oper%OperG(kk))
     $.and.Big_Operator(ExpR%Oper%OperG(jj))) 
     $   Call Swap_Mom(Momen1,Momen2)

C     Isign=-1 if the sign is changed due to commutator, 
C     i.e., for commutator of the type [C^,C_]
C     This can never happen
C      If(  Photon_Creation(ExpR%Oper%OperG(jj))
C     $.and.Photon_Destruction(ExpR%Oper%OperG(kk)))
C     $ExpR%IPowr(3)=ExpR%IPowr(3)+2

C     Add the necessary term to UVER
      Labljj = ExpR%Oper%OperG(jj)%Title(1:1)
      Lablkk = ExpR%Oper%OperG(kk)%Title(1:1)
      If(  Labljj.eq.'A'.and.Lablkk.eq.'A') then
         Call FormUV(ExpR,'U',jj,kk,Momen1)
      Else If(Labljj.eq.'A'.and.Lablkk.eq.'a') then
         Call FormUV(ExpR,'u',jj,kk,Momen1)
      Else If(Labljj.eq.'a'.and.Lablkk.eq.'A') then
         Call FormUV(ExpR,'u',jj,kk,Momen1)
      Else If(Labljj.eq.'B'.and.Lablkk.eq.'B') then
         Call FormUV(ExpR,'V',jj,kk,Momen1)
      Else If(Labljj.eq.'B'.and.Lablkk.eq.'b') then
         Call FormUV(ExpR,'v',jj,kk,Momen1)
      Else If(Labljj.eq.'b'.and.Lablkk.eq.'B') then
         Call FormUV(ExpR,'v',jj,kk,Momen1)
      Else If(Labljj.eq.'C'.and.Lablkk.eq.'C') then
         Call FndLtr(Lett,ExpR%Gam)
         Call FormE(ExpR,Lett,jj)
         Call FormE(ExpR,Lett,kk)
      Else If(Labljj.eq.'C'.and.Lablkk.eq.'c') then
         Call FndLtr(Lett,ExpR%Gam)
         Call FormE(ExpR,Lett,jj)
      Else If(Labljj.eq.'c'.and.Lablkk.eq.'C') then
         Call FndLtr(Lett,ExpR%Gam)
         Call FormE(ExpR,Lett,kk)
      End If

      Call CmmtTm(jj,kk,ExpR)

C     substitute momentum expressions
C     Momen1 and Momen2 are momentum expressions in 
C     commuting operators. Their difference forms an argument of
C     delta-function

C     Form difference Momen2-Momen1
      Argum = Momen2 - Momen1
      If(IPrint.ge.9) then
         Write(6,*) 'Argument of delta function='
         Call Write_Momentum(6,Argum)
      End If

      If(Argum%Length.eq.0) then
        Write(6,*) 'Warning!!! Delta with zero argument!'
        Return
      End If

      Call Delta_Product(Argum,ExpR)
     
      Return
      End
