      Function DeltaF(Exp1,Exp2)
C     Cancel terms if their sum makes energy delta-function
C     that is not on the mass shell
      Use ModXpr
      Use ModEnr
      Implicit None
      Type(Expression)      :: Exp1,Exp2
      Type(Energy) A,B
      Type(Energy) Term,AA,BB,ComFac
      Integer IDel,kk,FactorA,FactorB,i,ii,NumO,NMatch

      Logical DeltaF,Physic
      Integer IPrint
      COMMON /Print/ IPrint

C      Write(6,*)'DeltaF:IPrint= ',IPrint

      If(IPrint.ge.9) Call Output(6,Exp1,'DeltaF processing',1)
      If(IPrint.ge.9) Call Output(6,Exp2,'DeltaF processing',2)
      Deltaf=.false.

      If(Exp1%IPowr(1).ne.Exp2%IPowr(1)) Return
      If(Exp1%IPowr(2).ne.Exp2%IPowr(2)) Return

      Exp1%IPowr(3)=Mod(Exp1%IPowr(3),4)
      Exp2%IPowr(3)=Mod(Exp2%IPowr(3),4)
      IDel=Abs(Exp2%IPowr(3)-Exp1%IPowr(3))
      IDel=Mod(IDel,4)
      If(IDel.ne.2) then
         If(IPrint.ge.12)Write(6,*)'IDel.ne.2'
         Return
      End If
      If(IPrint.ge.12)Write(6,*)'IDel.eq.2'

C     Extract common factor from two exponents
      AA = Exp1%Exponent%Expi(2)
      BB = Exp2%Exponent%Expi(2)
      Call OrderEnergy(AA)
      Call OrderEnergy(BB)
      Term= ComFac(AA, BB)
C     Check if energy Term is double bracket
C      Call EnergySimplify(Term,NumO)
C     Now Term is a common factor
      AA = AA - Term
      BB = BB - Term         

 20   Continue
      If(AA%NumO.gt.0.and.BB%NumO.gt.0) then
C         If(AA%Sign.eq.BB%Sign) Return
         A = AA
         B = BB
         Call EnergySimplify(A,FactorA)
         Call EnergySimplify(B,FactorB)
         If(.not.(A.equal.-B)) Return


      Else If(AA%NumO.eq.0.and.BB%NumO.gt.0) then
         A = BB
         Call EnergySimplify(A,FactorA)

      Else If(AA%NumO.gt.0.and.BB%NumO.eq.0) then
         A = AA
         Call EnergySimplify(A,FactorA)

      Else
         Return
      End If

C     Find how many brackets in denominator match 
C     energy in the exponent. 
C 
      NMatch=0    
      Do kk=1,Exp1%Denominator%NumDen
         If( (A.equal. Exp1%Denominator%Denom(kk))
     $   .or.(A.equal.-Exp1%Denominator%Denom(kk))) NMatch=NMatch+1
      End Do
C           All tests passed: ii and jj form delta-function
C           Now we need to decide if argument of delta
C           can be zero. If not, then both terms can be annuled.
      If(NMatch.eq.0) then
C        Term (exp(iAT) - exp(-iAT))
C        Not sure about this!
         Continue
C         DeltaF=.true.
      Else If(NMatch.eq.1.and.(.not.Physic(A))) then
C        Term (exp(iAT) - exp(-iAT))/A with unphysical A
         If(IPrint.ge.9) Write(6,*) 'They form delta-function'
         DeltaF=.true.
      End If
      Return
      End
