      Module ModBrk
      Use ModEnr
      Implicit None
      Integer NumOmx
      Parameter(NumOmx=10)

      Type Bracket
         Integer                              ::  NumDen
         Type(Energy), Dimension(NumOmx)      ::  Denom         
      End Type Bracket

      Interface Operator (*)
         Module Procedure Bracket_Product
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_Brk
      End Interface
 
      Contains
C############################################################
      Function Greater_Than_Brk(A,B)
      Implicit None
      Type(Bracket),Intent(In)           :: A,B
      Logical                 :: Greater_Than_Brk
      Integer i
C     Here we assume that brackets A and B are already ordered

      Greater_Than_Brk = .false.
      If(A%NumDen.gt.B%NumDen) then
         Greater_Than_Brk = .true.
         Return
      Else If(A%NumDen.eq.B%NumDen) then
         Do i=1,A%NumDen
            If(A%Denom(i) .grth. B%Denom(i)) then
               Greater_Than_Brk = .true.
               Return
            Else If(B%Denom(i) .grth. A%Denom(i)) then
               Return
            End If
         End Do
      End If
      End Function Greater_Than_Brk
C############################################################
      Function Bracket_Product(A,B)
      Implicit None
      Type(Bracket),Intent(In)           ::  A,B
      Type(Bracket)                      ::Bracket_Product
      Integer                 ::  j, jj

      Bracket_Product%NumDen = A%NumDen + B%NumDen
      Do j=1,A%NumDen
         Bracket_Product%Denom(j) = A%Denom(j)
      End Do 
      Do j=1,B%NumDen
         jj=A%NumDen + j 
         Bracket_Product%Denom(jj) = B%Denom(j)
      End Do 
      End Function Bracket_Product  
C############################################################
      End Module ModBrk
