      Module ModEnr
      Use ModMom
      Use Md1Enr
      Use ModLet
      Implicit None
      Integer NumOme
      Parameter(NumOme=30)

      Type Energy
         Integer                              ::  NumO
         Integer                              ::  Sign
         Type(One_Energy), Dimension(NumOme)  ::  Energies
      End Type Energy

      Interface Operator (+)
         Module Procedure Energy_Add
      End Interface
      Interface Operator (-)
         Module Procedure Energy_Subtract, Change_Sign_Enr
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_Enr
      End Interface
      Interface Operator (.equal.)
         Module Procedure Equal_Enr
      End Interface

      Contains
C############################################################
      Function Energy_Add(A,B)
      Implicit None
      Type(Energy),Intent(In)                  ::  A,B
      Type(Energy)                             :: Energy_Add,C
      Integer i,ii

         C%NumO = A%NumO + B%NumO
         C%Sign = 1
         If(A%Sign.eq.1) then
            Do i=1,A%NumO
               C%Energies(i) = A%Energies(i)
            End Do
         Else If(A%Sign.eq.-1) then
            Do i=1,A%NumO
               C%Energies(i) = -A%Energies(i)
            End Do
         End If

         If(B%Sign.eq.1) then
            Do i=1,B%NumO
               ii=A%NumO+i
               C%Energies(ii) = B%Energies(i)
            End Do
         Else If(B%Sign.eq.-1) then
            Do i=1,B%NumO
               ii=A%NumO+i
               C%Energies(ii) = -B%Energies(i)
            End Do
         End If
         Call OrderEnergy(C)
         Energy_Add = C
      End Function Energy_Add
C############################################################
      Function Energy_Subtract(A,B)
         Implicit None
         Type(Energy),Intent(In)                  ::  A,B
         Type(Energy)                  ::  Energy_Subtract,C

         C = -B
         Energy_Subtract = A + C   
      End Function Energy_Subtract
C############################################################
      Function Greater_Than_Enr(AA,BB)
         Implicit None
         Type(Energy),Intent(In)       :: AA,BB
         Type(Energy) A,B
         Logical            :: Greater_Than_Enr
         Integer i,NumO
    
         A = AA
         B = BB
         Call OrderEnergy(A)
         Call OrderEnergy(B) 
         Greater_Than_Enr=.false.
         If(A%NumO.eq.0.and.B%NumO.eq.0) Return
         If(A%NumO.gt.B%NumO) then
            Greater_Than_Enr = .true.
            Return
         Else If(A%NumO.lt.B%NumO) then
            Return
         End If

         Do i=1,A%NumO
            If(A%Energies(i) .grth. B%Energies(i)) then
               Greater_Than_Enr=.true.
               Return
            Else If(B%Energies(i) .grth. A%Energies(i)) then
               Return
            End If
         End Do      
         If(A%Sign.gt.B%Sign) Greater_Than_Enr=.true.
      End Function Greater_Than_Enr
C############################################################
      Function Equal_Enr(A,B)
         Implicit None
         Type(Energy),Intent(In)          :: A,B
         Logical               :: Equal_Enr

         Equal_Enr = .false.
         If((.not.(A.grth.B)).and.(.not.(B.grth.A))) Equal_Enr = .true.
      End Function Equal_Enr
C############################################################
      Function Change_Sign_Enr(A)
         Implicit None
         Type(Energy),Intent(In)                  ::  A
         Type(Energy)                         :: Change_Sign_Enr
         Integer i

         Change_Sign_Enr = A
         Change_Sign_Enr%Sign = -Change_Sign_Enr%Sign
      End Function Change_Sign_Enr
C############################################################
      End Module ModEnr
