      Module ModOpr
      Use Md1Opr
      Use ModLet
      Implicit None
      Integer nmaxOp

      Parameter(nmaxOp = 20)

      Type Operator
         Integer                               :: NumOp
         Type(One_Operator), Dimension(nmaxOp) :: OperG
      End Type Operator

      Interface Operator (*)
         Module Procedure Operator_Product
      End Interface
      Interface Operator (.grth.)
         Module Procedure Greater_Than_Oper
      End Interface

      Contains
C############################################################
      Function Greater_Than_Oper(A,B)
      Implicit None
      Type(Operator),Intent(In)        :: A,B
      Logical               :: Greater_Than_Oper
      Integer i

      Greater_Than_Oper = .false.

      If(A%NumOp.gt.B%NumOp) then
         Greater_Than_Oper = .true.
         Return
      Else If(A%NumOp.lt.B%NumOp) then
         Return
      Else If(A%NumOp.eq.B%NumOp) then
         Do i=1,A%NumOp
            If(A%OperG(i) .grth. B%OperG(i)) then
               Greater_Than_Oper = .true.
               Return
            Else If(B%OperG(i) .grth. A%OperG(i)) then
               Return
            End If
         End Do
      End If
      End Function Greater_Than_Oper
C############################################################
      Function Operator_Product(A,B)
         Implicit None
         Type(Operator),Intent(In)           ::  A,B
         Type(Operator)           ::Operator_Product
         Integer j,jj

         Operator_Product%NumOp = A%NumOp + B%NumOp
         Do j=1,A%NumOp
            Operator_Product%OperG(j) = A%OperG(j)
         End Do 
         Do j=1,B%NumOp
            jj=A%NumOp + j 
            Operator_Product%OperG(jj) = B%OperG(j)
         End Do 
      End Function Operator_Product 
C############################################################
      End Module ModOpr
