      Subroutine NormTm(ICurr,Exp3,ExpR)

C     This program takes a term (Exp3)
C      transforms it to the normal form and writes all obtained
C     terms into the arrays of results (ExpR) 
C     ICurr ... current number of terms already included in 'R' arrays

      Use ModXpr
      Use Md1Opr
      Implicit None
      Type(Expression)                    :: Exp3
      Type(Expression), Dimension(NumExp) :: ExpR
      Logical Electron_Creation, Electron_Destruction
      Logical Positron_Creation, Positron_Destruction
      Logical Photon_Creation
      Logical Fermion_Operator, Electron_Operator

C     Internal arrays
      Integer ICurr,ITrms,ITerms,IPostn,IRefer,ICrOld,i,j
      Integer IPrint
      COMMON /Print/ IPrint

C     Next: put Oper3 into normal form
C     Original Oper3 will be put at position ICurr in 'R' 
C     arrays

C     Additional terms produced by pairing of operators during 
C     conversion of Oper3 to the normal form will start from 
C     ICrOld
C     ICrOld is the position at which the term after
C     pairing will stay. Terms from ICrOld to ICurr
C     are related to the ICrOld, ie. produced by converting
C     ICrOld into the normal form
      ICrOld=ICurr+1

C     Increment ICurr
      ICurr=ICurr+1

C     Fill new position in 'R' arrays with '3' arrays
      ExpR(ICurr) = Exp3

C     Now at ICurr is a term which should be converted to a normal form
      If(IPrint.ge.5) 
     $Call Output(6,Exp3,'Trying to convert to normal form the term',-1)
      ITrms=0
      ITerms=ICurr
      If(ITerms.ge.NumExp) Write(6,*)
     $'Warning!!! Number of terms exceeded allowed limit  ', NumExp

C     Loop over all terms produced by the current Oper3
 110  Continue
C     ICurr   ... the first element which is not yet in the normal form
C     ITerms ... last term written to the 'R' arrays
C     The do loop should go from ICurr to ITerms
C      We use ITrms to avoid changing the loop limit inside loop
      ITrms=ITerms

      Do i=ICurr,ITrms
C        First move all A^ to the leftmost positions
 20      Continue
         Do j=2,ExpR(i)%Oper%NumOp
            If(.not.Electron_Creation(ExpR(i)%Oper%OperG(j  ))) Cycle
            If(     Electron_Creation(ExpR(i)%Oper%OperG(j-1))) Cycle
      
            Call ExchangeOps(ExpR(i),ExpR,ITerms,j)
            Goto 20            
         End Do  

C        Next move all A_ to the leftmost (but to the right from A^ 
C        positions
 40      Continue
         Do j=2,ExpR(i)%Oper%NumOp
            If(.not.Electron_Destruction(ExpR(i)%Oper%OperG(j))) Cycle
            If(Electron_Operator(ExpR(i)%Oper%OperG(j-1))) Cycle

            Call ExchangeOps(ExpR(i),ExpR,ITerms,j)
            Goto 40
         End Do

C        Next move all B^ to the leftmost (but to the right from all A) 
C        positions
  60     Continue
         Do j=2,ExpR(i)%Oper%NumOp
            If(.not.Positron_Creation(ExpR(i)%Oper%OperG(j))) Cycle
            If( Electron_Operator(ExpR(i)%Oper%OperG(j-1))
     $      .or.Positron_Creation(ExpR(i)%Oper%OperG(j-1))) Cycle
            
            Call ExchangeOps(ExpR(i),ExpR,ITerms,j)
            Goto 60
         End Do

C        Next move all B_ to the leftmost (but to the right from all A 
C        and B^) positions
  80     Continue
         Do j=2,ExpR(i)%Oper%NumOp
            If(.not.Positron_Destruction(ExpR(i)%Oper%OperG(j))) Cycle
            If(Fermion_Operator(ExpR(i)%Oper%OperG(j-1))) Cycle

            Call ExchangeOps(ExpR(i),ExpR,ITerms,j)
            Goto 80
         End Do

C        Next move all C^ to the leftmost (but to the right from all 
C        A and B) positions
 100     Continue
         Do j=2,ExpR(i)%Oper%NumOp
            If(.not.Photon_Creation(ExpR(i)%Oper%OperG(j)))  Cycle
            If(Photon_Creation( ExpR(i)%Oper%OperG(j-1))
     $      .or.Fermion_Operator( ExpR(i)%Oper%OperG(j-1))) Cycle

            Call ExchangeOps(ExpR(i),ExpR,ITerms,j)
            Goto 100
         End Do

C        Now the terms from ICurr to ITrms are OK,however, 
C        newly created terms from
C        ITrms+1 to ITerms are not
C        OK.  We should repeat the same procedure for them.
      End Do
      ICurr=ITrms+1
C      Write(6,*) 'After do loop ICurr=',ICurr
      If(ITerms.ge.ICurr) goto 110
      ICurr=ICurr-1
C     If(ITerms.lt.ICurr) means we haven't produced new pairings,
C     so we can quit.
      Return
      End

