      Function Physic(Enrgy)
      Use ModEnr
      Use ModDNT
      Implicit None
      Type(Energy)   :: Enrgy,A
      Type(MomExp)        Delta
      Logical Physic,Letter
      Integer             :: NConn,m,j,NonZer,k,i
      Integer EnrSgn,Sign,Signi
      Type(MomExp)                      :: Zero,To,Is
      Type(Momentum) From

      Type(Energy), Dimension(NumOme) :: Term
C     Internal arrays
      Type(List) Momen1,Momen3,ListVariables
      Integer IPrint
      COMMON /Print/ IPrint


C     Determine whether energy in the bracket can become zero,
C     by the same rules as were used to determine physical terms
C     Determine connectivity of the Feynman diagram
C     and find out what is the type of the diagram
C     KType
C     0      Physical ...  All parts are physical
C     1      Renorm   ...  At least one part is renorm,no parts are
C                          unphysical
C     2      Unphysical ... At least one part is unphysical
C      These numbers will be put in array IConn

C     Physic=.false. if Enrgy cannot be zero
C     Physic=.true. if Enrgy can be zero

      Physic=.true.

      If(Enrgy%NumO.eq.1) then
         Physic=.false.
         Return
      Else  If(Enrgy%NumO.eq.0) then
         Return
      End If

      A = Enrgy

C     Apply delta-function to A
C      If(Delta%Length.gt.0) then
C         Is = Delta
C         From = VarOKtoChange(Is)
C         Zero%Length = 0
C         Call MakeFromTo(Is,Zero,From,To)
C         Do m=1,A%NumO
C            Call ChangeVariables
C     $      (A%Energies(m)%Momentum,From,To)
C         End Do
C         Call OrderEnergy(A)
C      End If

      NConn=0
      Do m=1,NumOme
         Term(m)%NumO = 0
         Term(m)%Sign = 1
      End Do

      Do m=1,NumOme
C        Start new subdiagram
C        Momen1 accumulates momentum labels of the subdiagram
C        Terms that have ben joined to the subdiagram are marked by
C        setting A%Energies(j)%Momentum%Length to 0
         Do j=1,A%NumO
            If(A%Energies(j)%Momentum%Length.eq.0)Cycle

            Momen1= ListVariables(A%Energies(j)%Momentum,'*')
            NConn=NConn+1
            Term(NConn)%NumO = 1
            Term(NConn)%Energies(1) = A%Energies(j)
            A%Energies(j)%Momentum%Length = 0
            Goto 56
         End Do
C        No more subdiagrams
         Exit
 56      Continue
         NonZer=0
         Do j=1,A%NumO
C           Eliminate all terms in the same group as Momen1
            If(A%Energies(j)%Momentum%Length.eq.0)Cycle

            Momen3=ListVariables(A%Energies(j)%Momentum,'*')
            If(Letter(Momen1,Momen3)) then
               Momen1 = Momen1 * Momen3
               Call ShrinkList(Momen1)
              
               Term(NConn)%NumO = Term(NConn)%NumO +1
               Term(NConn)%Energies(Term(NConn)%NumO) = A%Energies(j)
               A%Energies(j)%Momentum%Length = 0
               NonZer=1
            End If
         End Do
         If(NonZer.eq.1) Goto 56
C           There is a chance to find more terms from this group
      End Do
      If(IPrint.ge.10) Write(6,*) 'NConn= ',NConn

      Do i=1,NConn
         Call OrderEnergy(Term(i))
      End Do
C     Now Term() contains disconnected energy parts

C######################################################
C     This code declares term unphysical if  at least
C     one component is unphysical
C      Do i=1,NConn
C         If(EnrSgn(Term(i)).eq.0) Cycle
C         Physic = .false.
C         Return
C      End Do
C######################################################

C######################################################
C     This code declares term physical if total energy
C     can be zero
      Sign = EnrSgn(Term(1))
      If(NConn.eq.1.and.Sign.ne.0) then
         Physic=.false.
         Return
      Else If(Sign.eq.0) then
         Return
      End If

      Do i=2,NConn
         Signi = EnrSgn(Term(i))
         If(Signi.eq.0.or.Signi.ne.Sign) Return
      End Do
C     All components have the same sign - energy cannot be zero
      Physic = .false.
C######################################################
      Return
      End
