      Function TrySum(Exp1,Exp2)
      Use ModXpr
      Implicit None

      Type(Expression) Exp1,Exp2
      Type(Bracket) A,B
      Type(Energy) ABrack, BBrack, Brack, Mass,Br1,Br3
      Logical TrySum,Physic,PhysBr
      Integer i,j,IDif,IBrA,IBrB
      Integer IType
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

      TrySum=.false.
C     First find brackets in DenomR and DenomQ that are not equal

      A=Exp1%Denominator
      B=Exp2%Denominator

      Do i=1,A%NumDen
         If(A%Denom(i)%NumO.eq.0) Cycle
         Do j=1,B%Numden
            If(B%Denom(j)%NumO.eq.0) Cycle
            If(A%Denom(i).equal.B%Denom(j)) then
               A%Denom(i)%NumO=0
               B%Denom(j)%NumO=0
               Exit
            End If
         End Do
      End Do
      IBrA=0
      Do i=1,A%NumDen
         If(A%Denom(i)%NumO.ne.0.and.IBrA.eq.0) then
            IBrA = i
            ABrack = A%Denom(i)
         Else If(A%Denom(i)%NumO.ne.0.and.IBrA.ne.0) then
C           More than 1 bracket in A is not equal to B
            Return
         End If
      End Do

      IBrB=0
      Do i=1,B%NumDen
         If(B%Denom(i)%NumO.ne.0.and.IBrB.eq.0) then
            IBrB = i
            BBrack = B%Denom(i)
         Else If(B%Denom(i)%NumO.ne.0.and.IBrB.ne.0) then
C        More than 1 bracket in B is not equal to A
            Return
         End If
      End Do
      If(IBrA.eq.0.and.IBrB.eq.0) then
C        We found that all brackets are equal. These terms
C        can only differ by their sign
         Exp1%IPowr(3) = Mod(Exp1%IPowr(3),4)
         Exp2%IPowr(3) = Mod(Exp2%IPowr(3),4)
         If(Exp1%IPowr(3).eq. Exp2%IPowr(3)) then
            Exp1%IPowr(1) = Exp1%IPowr(1) * 2
            TrySum=.true.
            Return
         Else If(Exp1%IPowr(3).ne. Exp2%IPowr(3)) then
            Exp1%IPowr(1) = 0
            TrySum=.true.
            Return
         End If
      End If
      If(IBrA.eq.0.or.IBrB.eq.0) Return

      If(IPrint.ge.10) then
         Write(6,*) 'Found two non-equal energies'
         Call Write_Energy(6,ABrack)
         Call Write_Energy(6,BBrack) 
      End If

C     Form either sum or difference of ABrack and BBrack
      IDif=Abs(Exp1%IPowr(3)-Exp2%IPowr(3))
      IDif=Mod(IDif,4)
      If(IDif.eq.0) then
         Brack = ABrack + BBrack
      Else If(IDif.eq.2) then
         Brack = BBrack - ABrack
      Else
         Write(6,*) 'Warning!!! Wrong IDif'
      End If

C     Do not proceed if Brack is zero on the mass shell
      Mass= Exp1%Exponent%Expi(1)
      Br1 = Brack + Mass
      Br3 = Brack - Mass

C      If(Br1%NumO.eq.0.or.Br3%NumO.eq.0.or.Brack%NumO.eq.0) Return
C     What about total sign of the bracket?


C     Check if Brack coincides with one of remaining brackets in A
C     Brack is numerator of the sum of two expressions

      A=Exp1%Denominator
      If(IType.ne.6) then
         Do i=1,A%NumDen
            If(Brack.equal.A%Denom(i)) then
C              Instead of bracket i put here BBrack

               Exp1%Denominator%Denom(i) = BBrack            
               TrySum=.true.
               Exit
            Else If(Brack.equal.-A%Denom(i)) then
C              Instead of bracket i put here BBrack

               Exp1%Denominator%Denom(i) = BBrack
               Exp1%IPowr(3) = Exp1%IPowr(3) +2
               TrySum=.true.
               Exit
            End If
         End Do
         Return
      End If
C     Else If(IType.eq.6) then
C     First check that denominator doesn't contain 
C     physical brackets. Otherwise zeroes in denominator
C     will produce additional delta functions and the
C     trick below won't work.

C      If(PhysBr(A)) Return
C      If(Physic(BBrack)) Return

C     If Brack=0 on the mass shell then both Exp1 and Exp2 cancel
C     Exp2 will be set to zero in summa()
C      If(Br1%NumO.eq.0.or.Br3%NumO.eq.0.or.Brack%NumO.eq.0) then
C         TrySum=.true.
C         Exp1%IPowr(1) = 0
C         Return
C      End If

 20   Continue
      Do i=1,A%NumDen
         If((Brack.equal.A%Denom(i)).or.(Br1.equal.A%Denom(i))
     $   .or.(Br3.equal.A%Denom(i))) then
C           Instead of bracket i put here BBrack

            Exp1%Denominator%Denom(i) = BBrack
            TrySum=.true.
            Exit
         Else If((Brack.equal.-A%Denom(i)).or.(Br1.equal.-A%Denom(i))
     $   .or.(Br3.equal.-A%Denom(i))) then
C           Instead of bracket i put here BBrack

            Exp1%Denominator%Denom(i) = BBrack
            Exp1%IPowr(3) = Exp1%IPowr(3) +2
            TrySum=.true.
            Exit
         End If

      End Do

      Return
      End
