C############################################################
      Subroutine OrderEnergy(A)
         Use ModEnr
         Implicit None
         Type(Energy)       :: A,B,C
         Type(One_Energy) Find_Largest_Enr
         Integer i,j,ii
         Integer k,m

         Do i=1,A%NumO
            Call OrderMomExp(A%Energies(i)%Momentum)
         End Do

C        Make first sign plus in all momexps
         Do k=1,A%NumO
            If(A%Energies(k)%Momentum%Momenta(1)%Sign.eq.-1) 
     $      A%Energies(k)%Momentum = -A%Energies(k)%Momentum
         End Do

         If(A%NumO.le.1) Return

C        Cancel opposite energies
         B = A
         Do i=1,B%NumO
            If(B%Energies(i)%Title.eq.'xx') Cycle
            Do j=i+1,B%NumO
               If(B%Energies(j)%Title.eq.'xx') Cycle
               If(-B%Energies(i).equal.B%Energies(j)) then
                  B%Energies(i)%Title = 'xx'
                  B%Energies(j)%Title = 'xx'
                  Exit
               End If
            End Do
         End Do
         ii = 0
         Do i=1,B%NumO 
            If(B%Energies(i)%Title.eq.'xx') Cycle
            ii = ii +1
            A%Energies(ii) = B%Energies(i)
         End Do        
         A%NumO = ii

C        Order energies in decreasing sequence
         C%NumO = A%NumO
         C%Sign = A%Sign
         B = A
         Do k=1,A%NumO
            C%Energies(k)=Find_Largest_Enr(B,m)
            B%Energies(m)%Title='##'
         End Do
         If(C%Energies(1)%Sign.eq.-1) then
            C%Sign = -C%Sign
            Do i=1,C%NumO
               C%Energies(i) = -C%Energies(i)
            End Do
         End If
         A = C
         Return
      End 
C############################################################
      Subroutine EnergySimplify(A,Factor)
         Use ModEnr
         Implicit None
         Type(Energy)       :: A
         Type(One_Energy) Reference
         Integer i,j,Factor,NumTer,ICount

C        Try to extract a common factor
C        This subroutine is not used yet
         Factor=1
         Do i=2,A%NumO
            If(A%Energies(i).equal.A%Energies(1)) Cycle
            Factor = i-1
            Exit
         End Do
         NumTer = A%NumO/Factor
         If(NumTer*Factor .ne. A%NumO) then
            Factor=1
            Return
         End If
         ICount=0
         Do i=1,NumTer
            Do j=1,Factor
               ICount=ICount+1
               If(j.eq.1) then 
                  Reference = A%Energies(ICount)
               Else
                  If(A%Energies(ICount).equal.Reference) Cycle
                  Factor=1
                  Return
               End If
            End Do
         End Do
         A%NumO=NumTer
         Do i=1,A%NumO
            j=(i-1)*Factor+1
            A%Energies(i) = A%Energies(j)
         End Do
         Return
      End 
C############################################################
      Function Find_Largest_Enr(B,k)

C        Input ... Energy B
C        Output ... returns the largest one-energy term
C               ... position of the returned term in B
         Use ModEnr
         Implicit None
         Type(Energy)   :: B
         Integer        :: k
         Type(One_Energy) :: Current,Find_Largest_Enr
         Integer i,IStart
           
         Do i=1,B%NumO
            If(B%Energies(i)%Title.eq.'##') Cycle
            Current = B%Energies(i)
            IStart=i+1
            k = i
            Goto 20
         End Do
         Write(6,*) 'Warning!! Cannot find largest energy'
 20      Continue
         Do i=IStart,B%NumO
            If(B%Energies(i)%Title.eq.'##') Cycle
            If(B%Energies(i) .grth. Current) then
               Current=B%Energies(i)
               k=i
            End If
         End Do
         Find_Largest_Enr=Current
         Return
      End 
C############################################################
      Function DivInd(A,M)
C        Divergence index of energy with respect to 
C        momentum M
C        DivInd/2 = power of momentum M in denominator
         Use ModEnr
         Implicit None
         Type(Energy)  :: A
         Character     :: M
         Integer       :: DivInd,j,INumbe,Find
         Logical MomExpContainsMom

         DivInd = 0
         If(A%NumO.eq.1.and.A%Energies(1)%Title.eq.'Oz'.and.
     $   MomExpContainsMom(A%Energies(1)%Momentum,M)) then
            DivInd =  1
            Return
         End If
C        Assume that if A%NumO > 1 then this energy contains only
C        Om and Os terms
         INumbe=0
         Find = 0
         Do j=1,A%NumO
            If(MomExpContainsMom
     $      (A%Energies(j)%Momentum,M)) then
               Find = 1
               If(A%Energies(j)%Sign.eq.1) then
                  INumbe=INumbe+1
               Else If(A%Energies(j)%Sign.eq.-1) then
                  INumbe=INumbe-1
               End If
            End If
         End Do
         If(INumbe.eq.0.and.Find.eq.1) then
C           In this case we have difference of two terms having power 1.
C           This results in power 2
            DivInd=4
         Else If(INumbe.ne.0.and.Find.eq.1) then
            DivInd=2
         End If
         Return
      End 
C############################################################
      Function ListVariablesEn(A,Labl)
         Use ModEnr
         Use ModMom
         Implicit None
         Type(Energy)             :: A
         Type(List)                   :: ListVariablesEn
         Type(List) ListVariables
         Integer i
         Character Labl

         ListVariablesEn%Length = 0
         If(A%NumO.eq.0) Return
         ListVariablesEn 
     $   = ListVariables(A%Energies(1)%Momentum,Labl)
         Do i=2,A%NumO
            ListVariablesEn = ListVariablesEn 
     %      * ListVariables(A%Energies(i)%Momentum,Labl)
         End Do
         Call ShrinkList(ListVariablesEn)
         Return
      End 
C############################################################
      Function Extract_Energy(Momen1)
C     Opposite to EnergyToString
      Use ModEnr
      Use ModMom
      Implicit None
      Type(Energy) Extract_Energy
      Type(List) Momen1,Momen2
      Type(MomExp) ExtractMomExp
      Integer, Dimension(NumOme)   :: ISLOp3
      Integer i,CharToInt
      Integer IPrint
      COMMON /Print/ IPrint

      Call PntLst
     $(Extract_Energy%NumO,Momen1%Body(:Momen1%Length),
     $ISLOp3,'(',NumOme,1,Momen1%Length)
      ISLOp3(Extract_Energy%NumO+1) = Momen1%Length+3
C     ISLOp3 contains pointers to left parentheses '(' in
C     string Momen1

      Do i=1,Extract_Energy%NumO
         Extract_Energy%Energies(i)%Sign =
     $   CharToInt( Momen1%Body(ISLOp3(i)-3:ISLOp3(i)-3))
         Extract_Energy%Energies(i)%Title
     $   = Momen1%Body(ISLOp3(i)-2:ISLOp3(i)-1)

C        String Momen2 contains momentum expression
         Momen2%Length = ISLOp3(i+1) - ISLOp3(i) - 3
         Momen2%Body(:Momen2%Length) 
     $   = Momen1%Body(ISLOp3(i):ISLOp3(i+1)-4)
         Extract_Energy%Energies(i)%Momentum
     $   = ExtractMomExp(Momen2)
      End Do
      Extract_Energy%Sign = CharToInt(Momen1%Body(1:1))
      Return
      End 
C############################################################
      Function EnergyToString(A)
         Use ModEnr
         Use ModLet
         Use ModMom
         Implicit None
         Type(Energy) A
         Type(List) EnergyToString,Momen,B
         Type(List) OneEnergyToString
         Character IntToChar
         Integer i

         EnergyToString%Length=2
         EnergyToString%Body(1:1)=IntToChar(A%Sign)
         EnergyToString%Body(2:2)='['
         Do i=1,A%NumO
            Momen= OneEnergyToString(A%Energies(i))
            EnergyToString=EnergyToString * Momen
         End Do
         EnergyToString%Length=EnergyToString%Length+1
         EnergyToString%Body
     $   (EnergyToString%Length:EnergyToString%Length)=']'
         Return     
      End 
C############################################################
      Subroutine Write_Energy(NumFil,A)
         Use ModEnr
         Implicit None
         Type(Energy) A
         Type(List) Momen5,EnergyToString
         Integer NumFil

         Momen5=EnergyToString(A)
         Write(NumFil,*) Momen5%Body(:Momen5%Length)
         Return
      End
C############################################################
      Function OneEnergyToString(A)
         Use ModLet
         Use ModMom
         Use Md1Enr
         Implicit None
         Type(One_Energy)  A
         Type(List) B,OneEnergyToString,MomExpToString
         Character IntToChar


           B = MomExpToString(A%Momentum)
           OneEnergyToString%Length=B%Length+3
           OneEnergyToString%Body(1:OneEnergyToString%Length)=
     $      IntToChar(A%Sign)//A%Title//B%Body(:B%Length)
      Return
      End
C############################################################
      Function FindMatch(A,En)

C     Returns .true. if A is contained in energy En
C     Puts ## as title of A in En
         Use ModEnr
         Implicit None
         Type(One_Energy)  A
         Type(Energy) En
         Logical FindMatch
         Integer i

      FindMatch = .false.
      Do i=1,En%NumO
         If(A.equal.En%Energies(i)) then
            FindMatch = .true.
            En%Energies(i)%Title = '##'
            Return
         End If
      End Do

      Return
      End
C############################################################

