C############################################################
      Subroutine MomAlp(A)
C        Alphabetically order momenta in A.
C        Put result in MomAlp
         Use ModMom
         Implicit None
         Type(MomExp)   :: A,C,B
         Type(Momentum) Find_Largest
         Integer k,m
      
         If(A%Length.le.1) Return      
         C%Length = A%Length
         B = A
         Do k=1,A%Length
            C%Momenta(k)=Find_Largest(B,m)
            B%Momenta(m)%Char='#'
         End Do
         A = C
      Return
      End
C############################################################
      Subroutine OrderMomExp(A)
C        Bring MomExp A to the standard form
         Use ModMom
         Implicit None
         Type(MomExp)   :: A
            
         Call MomAlp(A)
         Call Cancel(A)
      Return
      End 
C############################################################
      Function Find_Largest(B,k)
         Use ModMom
         Implicit None
         Type(MomExp)   :: B
         Integer        :: k,i,IStart
         Type(Momentum) :: Current,Find_Largest
            
         Do i=1,B%Length
            If(B%Momenta(i)%Char.eq.'#') Cycle
            Current = B%Momenta(i)
            k=i
            IStart=k+1
            Exit
         End Do
         Do i=IStart,B%Length
            If(B%Momenta(i)%Char.eq.'#') Cycle
            If(B%Momenta(i) .grth. Current) then
               Current=B%Momenta(i)
               k=i
            End If
         End Do
         Find_Largest=Current
      Return
      End 
C############################################################
      Subroutine Cancel(A)
C        Cancel opposite momenta in momexp A
         Use ModMom
         Implicit None
         Type(MomExp)        :: A,B
         Integer i,IStart,j

         If(A%Length.le.1) Return
         B=A
         Do i=1,B%Length
            If(B%Momenta(i)%Char.eq.'#') Cycle
            Do j=i+1,B%Length
               If(B%Momenta(j)%Char.eq.'#') Cycle
               If(   B%Momenta(j)%Char.eq.B%Momenta(i)%Char
     $         .and.-B%Momenta(j)%Sign.eq.B%Momenta(i)%Sign
     $         .and. B%Momenta(j)%Labl.eq.B%Momenta(i)%Labl) then
                   B%Momenta(j)%Char = '#'
                   B%Momenta(i)%Char = '#'
                   Exit
               End If
            End Do
         End Do
         IStart=0
         Do i=1,B%Length
            If(B%Momenta(i)%Char.eq.'#') Cycle
            Istart=IStart+1
            A%Momenta(IStart)=B%Momenta(i)            
         End Do 
         A%Length=IStart 
      Return       
      End 
C############################################################
      Subroutine SubstituteLabels(A,From,To)
         Use ModMom
         Implicit None
         Type(MomExp)                :: A
         Character                   :: From, To
         Integer i

         Do i=1,A%Length
            If(A%Momenta(i)%Labl.eq.From)
     $         A%Momenta(i)%Labl=To
         End Do
      Return
      End 
C############################################################
      Subroutine ChangeVariables(A,From,To)
      Use ModMom
      Implicit None
      Type(MomExp)                :: A
      Type(MomExp)                :: To,ToAdd
      Type(Momentum)              ::From
C     Internal Array
      Type(MomExp)                :: B,C,Form_MomExp
      Integer N,i,NumMomInMomExp

      Call Cancel(A)
      N = NumMomInMomExp(From,A)
      If(N.eq.0) Return
      C = Form_MomExp(From)
      ToAdd = To - C
  
      If(N.lt.0) then
         N = -N
         ToAdd=-ToAdd
      End If
      Do i=1,N
         B = A + ToAdd
         A = B
      End Do
      Return        
      End 
C############################################################
      Function Form_MomExp(A)
C        Write momentum A in the form of MomExp
C        Put result in Form_MomExp
         Use ModMom
         Implicit None
         Type(MomExp)                 :: Form_MomExp
         Type(Momentum)               :: A
         
         Form_MomExp%Length = 1
         Form_MomExp%Momenta(1) = A
      Return
      End  
C############################################################
      Function NumMomInMomExp(A,B)
C        Returns number of occurences of momentum A
C        in momexp B. If momentum A enters with the opposite
C        sign then returns negative number.
         Use ModMom
         Implicit None
         Type(MomExp)                 :: B
         Type(Momentum)               :: A,C
         Integer                      :: NumMomInMomExp,i

         NumMomInMomExp = 0
         Do i=1,B%Length
            If((B%Momenta(i)%Sign.eq.A%Sign).and. 
     $         (B%Momenta(i)%Char.eq.A%Char).and.
     $         (B%Momenta(i)%Labl.eq.A%Labl))
     $      NumMomInMomExp = NumMomInMomExp +1
         End Do
         If(NumMomInMomExp.gt.0) Return
         C=-A
         Do i=1,B%Length
            If((B%Momenta(i)%Sign.eq.C%Sign).and.
     $         (B%Momenta(i)%Char.eq.C%Char).and.
     $         (B%Momenta(i)%Labl.eq.C%Labl))
     $      NumMomInMomExp = NumMomInMomExp-1
         End Do
      Return
      End  
C############################################################
      Function ExtractLabeledMom(A,Label)
         Use ModMom
         Implicit None
         Type(MomExp)                      :: A
         Character                         :: Label
         Type(Momentum)                    :: ExtractLabeledMom
         Integer i

         Do i=1,A%Length
            If(A%Momenta(i)%Labl.eq.Label) then
               ExtractLabeledMom = A%Momenta(i)
               Return
            End If
         End Do
         ExtractLabeledMom%Labl='#'
      Return
      End 
C############################################################
      Function MomExpContainsMom(A,M)
         Use ModMom
         Implicit None
         Type(MOmExp)                  :: A
         Character                     :: M
         Logical                       :: MomExpContainsMom
         Integer i

         MomExpContainsMom = .false.
         Do i=1,A%Length
            If(A%Momenta(i)%Char.eq.M) then
               MomExpContainsMom = .true.
               Exit
            End If
         End Do
      Return
      End 
C############################################################ 
      Function ListVariables(A,Labl)
         Use ModMom
         Implicit None
         Type(MomExp)                 :: A
         Type(List)                   :: ListVariables
         Integer i,ii
         Character Labl

         ii = 0
         Do i=1,A%Length
            If(A%Momenta(i)%Labl.eq.Labl) then
               ii=ii+1
               ListVariables%Body(ii:ii) 
     %         = A%Momenta(i)%Char
            End If
         End Do
         ListVariables%Length=ii
         Call ShrinkList(ListVariables)
      Return
      End 
C############################################################
      Subroutine Swap_Mom(A,B)
         Use ModMom
         Implicit None
         Type(MomExp)                 :: A,B,C

         C=A
         A=B
         B=C
      Return
      End 
C############################################################
      Function ExtractMomExp(A)
C        Extract momexp from a string (momexp in parentheses)
         Use ModMom
         Implicit None
         Type(List) A
         Type(MomExp) ExtractMomExp
         Integer i,IStart,L,CharToInt

         L = A%Length-2
         If(L/3*3.ne.L) then
            Write(6,*)'Warning!!! MomExp has wrong length!'
         Else If(L.eq.0) then
            ExtractMomExp%Length = 0
         Else
            ExtractMomExp%Length = L/3
            IStart = -1
            Do i=1,ExtractMomExp%Length
               IStart=IStart + 3
               ExtractMomExp%Momenta(i)%Sign = 
     $         CharToInt(A%Body(IStart:IStart))
               ExtractMomExp%Momenta(i)%Char 
     $         = A%Body(IStart+1:IStart+1)
               ExtractMomExp%Momenta(i)%Labl 
     $         = A%Body(IStart+2:IStart+2)
            End Do
         End If
      Return
      End 
C############################################################      
      Function MomExpToString(A)
         Use ModMom
         Use ModLet
         Implicit None
         Type(MomExp)   A
         Type(List) MomExpToString,B
         Integer i
         Character IntToChar

         MomExpToString%Length=1
         MomExpToString%Body(1:1)='('
         Do i=1,A%Length
            B%Length=3
            B%Body(1:1)=IntToChar(A%Momenta(i)%Sign)
            B%Body(2:2)=A%Momenta(i)%Char
            B%Body(3:3)=A%Momenta(i)%Labl
         
            MomExpToString=MomExpToString * B
         End Do
         MomExpToString%Length=MomExpToString%Length+1
         MomExpToString%Body
     $   (MomExpToString%Length:MomExpToString%Length)=')'
      Return
      End 
C############################################################
      Subroutine Write_Momentum(NumFil,A)
         Use ModMom
         Implicit None
         Type(MomExp) A
         Type(List) B,MomExpToString
         Integer NumFil

         B=MomExpToString(A)
         Write(NumFil,*)B%Body(:B%Length)
      Return
      End 
C############################################################
      Subroutine MakeFromTo(Is,Want,From,To)
C     One should change variables from 'From' to 'To' if
C     one wants to change everywhere 'Is' to 'Want' 
      Use ModMom
      Implicit None
      Type(MomExp) Is,Want,Can,To,Form_MomExp
      Type(Momentum) From
      Integer NumMomInMomExp

      Can = Form_MomExp(From)
      Call Cancel(Is)
      If(NumMomInMomExp(From,Is).eq.0) then
         Write(6,*) 'Warning!!!'
         Write(6,*) 'Cannot make'
         Call Write_Momentum(6,Want)
         Write(6,*) 'from'
         Call Write_Momentum(6,Is)
         Write(6,*) 'By changing'
         Call Write_Momentum(6,Can)
         Return
      End If
      To = Can - Is + Want
      Return
      End 
C############################################################
      Function FindNewMom(UsedMoms)
C     Forms a momexp such that its variable doesn't repeat
C     those collected in UsedMoms
         Use ModMom
      Implicit None
      Type(MomExp) FindNewMom
      Type(List) UsedMoms
      Character FindNewLetter

         FindNewMom%Length = 1
         FindNewMom%Momenta(1)%Sign = 1
         FindNewMom%Momenta(1)%Char = FindNewLetter(UsedMoms)
         FindNewMom%Momenta(1)%Labl = '*'
      Return
      End 
C############################################################
      Function CharToMom(Char,Label)
C     Forms momentum with name 'Char' and label 'Label'
      Use ModMom
      Implicit None
      Type(Momentum) CharToMom
      Character Char,Label

      CharToMom%Sign = 1
      CharToMom%Char = Char
      CharToMom%Labl = Label
      
      Return
      End
